Subject: Re: [Anima-bootstrap] Brian: Text to discover "Registrars" via GRASP

From: Brian E Carpenter <[email-masked]>
Date: Fri, 23 Sep 2016 13:21:32 +1200

On 23/09/2016 12:12, Michael Richardson wrote:
> 
> {why isn't this on the list???}

Assuming you mean the bootstrap DT list, only because it started as a
very specific discussion point. So now it's on the list.

> 
> Brian E Carpenter <[email-masked]> wrote:
>     > On 13/09/2016 12:52, Toerless Eckert wrote:
>     >> On Tue, Sep 13, 2016 at 11:12:20AM +1200, Brian E Carpenter wrote:
>>>>>> Currently we have:
>>>>>>       BRSKY via TLS/TCP
>>>>>>       BRSKY via CoAP/dTLS/UDP via IPIP
>     >>
>     >> I am actually confused right now why i added the "IPIP" into the mix...
>     >> *head* *scratching*
> 
>     > Yes, if you're inside the ACP it certainly seems redundant.
> 
> Either there are TCP/UDP circuit layer proxies (aka NAT66s or application
> layer alg-gateways), or there is an IPIP layer. In the later case, the
> packets look like:
> 
> pledge                     proxy                      registrar
> A ----- src:llA/dst:llP---->   ---src:acpP/dst:acpR------> R
>                                  IPIP:src:llA/dst:llP
> 
> We need the IPIP layer on the ACP side because the pledge/proxy
> communication is link-local only.

Sure. And I think we do need to settle the question of which method
is used. What is the advantage in the registrar seeing the link-local
addresses, which are never supposed to be visible off-link? Would
it help for diagnostics? If we want that, we want IPIP. If not, NAT66
would need to clamber over innumerable dead bodies). So then a transport
proxy seems best (to preserve end2end TLS).

> If the CoAP and TCP versions are different ASAs, then they can return
> different addresses and port numbers.
> If they are on the same ASA, I guess, yes, we need to return to answers.

Right. I assumed the second case for my demo code because it's more
demanding on GRASP.

   Brian